

#define EXPAN_1    0    /* I2C address for IO expander 1 */
#define EXPAN_2    1    /* I2C address for IO expander 2 */

/* gate times */
#define GATE_1SEC       1
#define GATE_10SEC      10
#define GATE_100SEC     100

/* byte select constants for reading counters */
#define UNITX           0
#define UNITY           1
#define UNITZ           2
#define BYTE_NONE        0b11111111
#define BYTE_GAL         0b11111110
#define BYTE_GAU         0b11111101
#define BYTE_GBL         0b11111011
#define BYTE_GBU         0b11110111


void counter_init( void );
void counter_gate_select( uint8_t );
void counter_byte_select( uint8_t, uint8_t );
void counter_do_count( void );
void counter_reset( void );
void counter_rclk( void );
uint8_t counter_ready( void );

#ifndef IN_COUNTER_CTL
extern uint32_t unitx_count, unity_count, unitz_count;
#endif
