/* Copyright (c) 2015-2017, Mike Smith
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * o  Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * o  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * o  Neither the name of the <ORGANIZATION> nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#define MCP_IO_ERROR 0
#define MCP_SUCCESS  1

/* addresses of control registers on MCP23017 chip */
#define MCP_IODIRA     0x00
#define MCP_IODIRB     0x01
#define MCP_IPOLA      0x02
#define MCP_IPOLB      0x03
#define MCP_GPINTENA   0x04
#define MCP_GPINTENB   0x05
#define MCP_DEFVALA    0x06
#define MCP_DEFVALB    0x07
#define MCP_INTCONA    0x08
#define MCP_INTCONB    0x09
#define MCP_IOCON      0x0a
#define MCP_IOCON_II   0x0b
#define MCP_GPPUA      0x0c
#define MCP_GPPUB      0x0d
#define MCP_INTFA      0x0e
#define MCP_INTFB      0x0f
#define MCP_INTCAPA    0x10
#define MCP_INTCAPB    0x11
#define MCP_GPIOA      0x12
#define MCP_GPIOB      0x13
#define MCP_OLATA      0x14
#define MCP_OLATB      0x15

/* chip addresses */
#define MCP_KEYLCD_ADDR 0b00000001
#define MCP_PWM_ADDR    0b00000010
#define EEPROM_ADDR     0b00000100   /* this is 'illegal' to use with mcp */
                                     /* module -- use ee_* functions      */

uint8_t mcp_write_byte(uint8_t,uint8_t,uint8_t);
uint8_t mcp_read_byte(uint8_t,uint8_t,uint8_t *);

